--- old/usr/src/uts/common/fs/zfs/zfs_ioctl.c	Mon Oct 29 18:19:34 2012
+++ new/usr/src/uts/common/fs/zfs/zfs_ioctl.c	Mon Oct 29 18:19:34 2012
@@ -617,6 +617,8 @@
 		break;
 
 	case ZFS_PROP_QUOTA:
+	case ZFS_PROP_DATASET_QUOTA:
+	case ZFS_PROP_SNAPSHOT_QUOTA:
 		if (!INGLOBALZONE(curproc)) {
 			uint64_t zoned;
 			char setpoint[MAXNAMELEN];
@@ -2384,6 +2386,14 @@
 	case ZFS_PROP_REFQUOTA:
 		err = dsl_dataset_set_quota(dsname, source, intval);
 		break;
+	case ZFS_PROP_DATASET_QUOTA:
+		err = dsl_dir_validate_ds_ss_quota(dsname, intval,
+		    ZFS_PROP_DATASET_QUOTA);
+		break;
+	case ZFS_PROP_SNAPSHOT_QUOTA:
+		err = dsl_dir_validate_ds_ss_quota(dsname, intval,
+		    ZFS_PROP_SNAPSHOT_QUOTA);
+		break;
 	case ZFS_PROP_RESERVATION:
 		err = dsl_dir_set_reservation(dsname, source, intval);
 		break;
